"use strict";

var paper_x_dim = 920;
var paper_y_dim = 445;

var gameOnCurrentTimeXPos = 0;
var gameOnCurrentTimelineRect = null;

function updateGameOnCurrentTimeline()
{
    gameOnCurrentTimeXPos = (mediaPlayer.currentTime / mediaPlayer.duration) *  paper_x_dim;
    //console.log("*** x pos = " + gameOnCurrentTimeXPos);

    gameOnCurrentTimelineRect.attr({x: gameOnCurrentTimeXPos});
}

function initGameOn()
{
    console.log("initGameOn()");

    var gmp_x_dim = $('#gameOnPaper').width();
    var gmp_y_dim = $('#gameOnPaper').height();

    console.log("*** gmp_x_dim = " + gmp_x_dim);
    console.log("*** gmp_y_dim = " + gmp_y_dim);

    var paper_x_dim = 920;
    var paper_y_dim = 445;

    var num_midi_pitches = 128;

    //var paper = Raphael("gameOnPaper",gmp_x_dim,gmp_y_dim);
    var paper = Raphael("gameOnPaper",paper_x_dim,paper_y_dim);
    paper.canvas.style.backgroundColor = '#FFFFFF';

    console.log("*** hasLocalStorage = " + hasLocalStorage);

    if (hasLocalStorage) {
	var docOID = gs.cgiParams.d;
	
	var docStorageStr = localStorage.getItem(docOID);

	var docStorage = (docStorageStr != null) ? eval("("+docStorageStr+")") : {palTracks:{}, popTracks:{}};

	var palTracks = docStorage.palTracks || {};

	// 'palTracks' for the form:
	//    palTracks[save_name] = [ { name: "my recording 1", baseCTime: 123.3, events: [ .... ] } ]

	var my_recording = palTracks['My Recording'];

	if (my_recording != null) {
	    var total_duration = mediaPlayer.duration;
	    console.log("*** total duration = " + total_duration);

	    var min_midi_pitch = num_midi_pitches-1;
	    var max_midi_pitch = 0;

	    // calculate range of midi pitches present
	    for (var b=0; b<my_recording.length; b++) {
		var track_block = my_recording[b];
		var base_ctime = track_block.baseCTime;
		var block_events = track_block.events;

		for (var ne=0; ne<block_events.length; ne++) {
		    var midi_pitch = block_events[ne].midiPitch;
		    if (midi_pitch < min_midi_pitch) {
			min_midi_pitch = midi_pitch;
		    }
		    if (midi_pitch > max_midi_pitch) {
			max_midi_pitch = midi_pitch;
		    }
		}
	    }
	    console.log("*** max pitch = " + max_midi_pitch + ", min pitch = " + min_midi_pitch);

	    var raw_midi_range = max_midi_pitch - min_midi_pitch;
	    var midi_range = Math.max(4,raw_midi_range); 

	    var midi_y_dim_spacing = paper_y_dim / midi_range;

	    for (var b=0; b<my_recording.length; b++) {

		var track_block = my_recording[b];
		var base_ctime = track_block.baseCTime;

		var block_events = track_block.events;

		for (var ne=0; ne<block_events.length; ne++) {

		    var note_event = block_events[ne];
		    
		    var startPercTime = (base_ctime + note_event.startCurrentTime)/total_duration;
		    var rx_org = startPercTime * paper_x_dim;
		    var ry_org = paper_y_dim - ((note_event.midiPitch - min_midi_pitch) * midi_y_dim_spacing);
		    
		    var rx_dim = (note_event.duration/1000)/total_duration * paper_x_dim;
		    var ry_dim = midi_y_dim_spacing;
		    
		    var rect = paper.rect(rx_org,ry_org,rx_dim,ry_dim);
		    rect.attr({stroke:"black",fill:"#2E52A4"});
		}
	    }
	}
    }

    gameOnCurrentTimelineRect = paper.rect(-2,0,1,paper_y_dim);
    console.log("*** gameOnCurrentTimelineRect = " + gameOnCurrentTimelineRect);
    
    gameOnCurrentTimelineRect.attr({fill: "red", stroke: "red"});
    
}

function pamDelete()
{
    //var pamActiveLayers = $('input[type=checkbox]:checked', '#pamForm');

    var pamActiveLayers = [];
    $('#pamForm input:checked').each(function() {
        pamActiveLayers.push({name: this.name, value: this.value});
    });

    return false;
}
